import { Host, h } from '@stencil/core';
export class WebAccordion {
  openEventHandler(event) {
    const children = this.element.querySelectorAll('web-accordion-item');
    for (let i = 0; i < children.length; i++) {
      if (event.detail.index != i) {
        children[i].closeItem();
      }
    }
  }
  /**
   * Open an accordion item
   * @param index
   */
  async open(index) {
    this.getAccordionItem(index).openItem();
  }
  /**
   * close an accordion item
   * @param index
   */
  async close(index) {
    this.getAccordionItem(index).closeItem();
  }
  getAccordionItem(index) {
    const children = this.element.querySelectorAll('web-accordion-item');
    if (index >= 0 && index < children.length) {
      return children[index];
    }
    else {
      throw new Error("index out of bounds");
    }
  }
  render() {
    return (h(Host, null, h("slot", null)));
  }
  static get is() { return "web-accordion"; }
  static get encapsulation() { return "shadow"; }
  static get methods() {
    return {
      "open": {
        "complexType": {
          "signature": "(index: number) => Promise<void>",
          "parameters": [{
              "tags": [{
                  "name": "param",
                  "text": "index"
                }],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "Open an accordion item",
          "tags": [{
              "name": "param",
              "text": "index"
            }]
        }
      },
      "close": {
        "complexType": {
          "signature": "(index: number) => Promise<void>",
          "parameters": [{
              "tags": [{
                  "name": "param",
                  "text": "index"
                }],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "close an accordion item",
          "tags": [{
              "name": "param",
              "text": "index"
            }]
        }
      }
    };
  }
  static get elementRef() { return "element"; }
  static get listeners() {
    return [{
        "name": "openEvent",
        "method": "openEventHandler",
        "target": undefined,
        "capture": false,
        "passive": false
      }];
  }
}
