import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const WebAccordion$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  openEventHandler(event) {
    const children = this.element.querySelectorAll('web-accordion-item');
    for (let i = 0; i < children.length; i++) {
      if (event.detail.index != i) {
        children[i].closeItem();
      }
    }
  }
  /**
   * Open an accordion item
   * @param index
   */
  async open(index) {
    this.getAccordionItem(index).openItem();
  }
  /**
   * close an accordion item
   * @param index
   */
  async close(index) {
    this.getAccordionItem(index).closeItem();
  }
  getAccordionItem(index) {
    const children = this.element.querySelectorAll('web-accordion-item');
    if (index >= 0 && index < children.length) {
      return children[index];
    }
    else {
      throw new Error("index out of bounds");
    }
  }
  render() {
    return (h(Host, null, h("slot", null)));
  }
  get element() { return this; }
}, [1, "web-accordion", {
    "open": [64],
    "close": [64]
  }, [[0, "openEvent", "openEventHandler"]]]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["web-accordion"];
  components.forEach(tagName => { switch (tagName) {
    case "web-accordion":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, WebAccordion$1);
      }
      break;
  } });
}

const WebAccordion = WebAccordion$1;
const defineCustomElement = defineCustomElement$1;

export { WebAccordion, defineCustomElement };
