import { EventEmitter } from '../../stencil-public-runtime';
export declare class WebAccordionItem {
  protected calculatedHeight: number;
  protected mutationObserver: MutationObserver;
  get style(): {
    height: string;
  };
  element: HTMLElement;
  transitioning: boolean;
  /**
   * index of accordion item from top to bottom
   */
  index: number;
  /**
   * accordion item is open or opening (css transition)
   */
  open: boolean;
  /**
   * The mutation observer config to listen for content changes in the accordion item
   */
  mutationObserverConfig: {
    childList: boolean;
    subtree: boolean;
  };
  stateChanged(): void;
  /**
   * triggered when the accordion item is opened
   */
  openEvent: EventEmitter;
  /**
   * triggered when the content of the accordion item changes
   */
  contentChanged: EventEmitter;
  componentWillLoad(): void;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  /**
   * recalculate Height of accordion item (e.g., when the content of the item changes)
   */
  recalculateHeight(): void;
  /**
   * close the accordion item
   */
  closeItem(): Promise<void>;
  /**
   * open the accordion item
   */
  openItem(): Promise<void>;
  toggle(): void;
  handleTransitionEnd(): void;
  calculateHeight(): number;
  render(): any;
}
